# -*- coding: utf-8 -*-
"""
Created on Fri Nov 23 16:24:28 2018

@author: alfredoratesso
"""

i = 3700
fig = plt.figure(figsize=(6,5))
axes = fig.add_axes([0.1,0.9,0.5,0.8])
axes.plot(list_d[i],list_G[i])
plt.show()

####################################

list_G_diff_mean = []
num = 0

for i in range(len(list_G)):
    
    a = np.where(list_G[i] >= -1)[-1][-1]
    b = np.where(list_G[i] >= -6)[-1][-1]
    
    list_G_diff = np.diff(list_G[i]) / np.diff(list_d[i])
    if not np.isnan(np.mean(list_G_diff[a:b])):
        list_G_diff_mean.append(np.mean(list_G_diff[a:b]))
        if list_G_diff_mean[-1]>=-10 and list_G_diff_mean[-1]<=-5:
            print("slope: ",list_G_diff_mean[-1])
            print("index: ",i)
            num+=1
print(num)

####################################

list_G_diff_all = []

for i in range(len(list_G)):
    list_G_diff = np.diff(list_G[i]) / np.diff(list_d[i])
    if not np.isnan(list_G_diff.all()):
        list_G_diff_all.append(list_G_diff)

#######################################
            
fig = plt.figure(figsize=(6,5))
axes = fig.add_axes([0.1,0.9,0.5,0.8])
axes.plot(list_G_diff_mean)
plt.show()


#######################################
### Working -> CURVE OF SLOPE VS G! Add to K-Means as new feature?

list_G_sort, list_G_diff_sort = (list(t) for t in zip(*sorted(zip(list_G[i][:-1], list_G_diff))))

b = np.where(np.asarray(list_G_sort) <= 0)[-1][-1]
a = np.where(np.asarray(list_G_sort) <= -6)[-1][-1]

fig = plt.figure(figsize=(6,5))
axes = fig.add_axes([0.1,0.9,0.5,0.8])
axes.plot(list_G_sort[a:b],list_G_diff_sort[a:b])
plt.show()

####################################

fig = plt.figure(figsize=(8,4))
axes = fig.add_axes([0.1,0.9,0.5,0.8])
a = np.hstack(list_G_diff_mean)
plt.hist(a, bins='auto')
axes = plt.gca()
axes.set_xlim([-50,0.1])
axes.set_ylim([0,100])
plt.show()


###########################

list_G_histo = []
for num in range(len(list_histo2D)):
    list_G_histo.append(np.sum(list_histo2D[num],axis=0))
    
for num in range(len(list_G_histo)):
    if num==0:
        histo_G = list_G_histo[0]
        histo_diff_G = list_G_diff_all[0]
    else:
        histo_G = histo_G + list_G_histo[num]
    
histo_G = histo_G/len(list_G_histo)