function plot_1DHist(hist1D,yedges)
if nargin<2
	yedges = evalin('base','yedges');
end
%     Dmin=min(xedges);
%     Dmax=max(xedges);
    Gmin=log10(min(yedges));
    Gmax=log10(max(yedges));

   pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
 	pos2 = find(min(abs(yedges - 5e-7)) == abs(yedges - 5e-7));
 	MAX = max(hist1D(pos2:pos1));

	semilogx(yedges,hist1D,'LineWidth',2,'Color', [0.6445,0.8008,0.5352]);
	xlabel('Conductance (G_0)')
	ylabel('Counts / trace')
	set(gca,'fontsize',20,'fontweight','normal')
	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
	set(gca,'linewidth',0.5,'box','on')
	set(gcf,'color','white')
	%set(gca,'Xlim',[10^Gmin  3])
   set(gca,'Xlim',[5e-7 3])
	set(gca,'Ylim',[0 1.05*MAX])
	%set(gca,'XTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
	set(gca,'XTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
end
	