%% Clear
clear
close all
clc
Nfiles = 0;

%% Settings
%path = 'C:\Users\dstefani\Google Drive\Measurements\davide\Matlab\Test\Test_data\scan160204_0\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\Matthijs\OPE3NH2_DCM_1\3-7\';
%path = 'D:\dstefani\Research\2017\Peptide\MPA-2Ala-1Trp-1Cys\Sample 1\13-17\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in methanol\Sample 1\1-5\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in methanol\Sample 2\2-6\';
%path = 'D:\dstefani\Research\2017\Measurements in solution\OPE3-NH2 in acetonitrile\Sample 1\2-6\';
%path = 'H:\davide\OPE3-NH2 in ethanol\Sample 3\3-7\';
% path = 'G:\chunwei\Rotaxane\RM23_05\Gold\14-18\';
% path = 'H:\Chunwei\Helicene\Hel_diSAc_5\Molecule\3-7\';
path = 'E:\Data\Liquid_cell_setup\Helicene\Hel_NGS\Sample 1\molecule\16-20\';
%  path = 'E:\Data\Piezo_setup\Short_PCP\MetaMeta6\Molecule\16-18\';

path = strrep(path,'\','/');	%replaces backslashes with slashes in the path
% filename = 'scan190621_11';	%f
 filename = 'scan191010_15';
 
% files={'scan171114_91','scan171114_109','scan171114_113','scan171115_0','scan171115_1'};
% for file_temp=1:numel(files)
% filename = char(files(file_temp));	%
% close all
% clc
% Nfiles = 0;
% SteepnessFilter2
Plots=struct();
Plots.SumUp =                    1;		%2D,1D,Jevo and settings
Plots.Hist1D =                   1;		%1D histo
Plots.Hist2D =                   1;		%2D histo
Plots.JunctionEvolution =        1;		%Trace overview
Plots.G0Length =                 1;		%1G_0 Length
Plots.TotalLength =              1;		%Total length
Plots.Tunnelslope =              1;     %Tunneling slope
Plots.CorrelationHisto =         0;		%Correlation
Plots.Autocovariance =           0;    %Autocovariance
Plots.TunnelingRemoval	=        0;		%Tunneling removal and histograms
Plots.ConductanceSelection =  	0;		%Conditional histogram
Plots.JFormationProb =           0;		%Junction formation probability
Plots.JunctionUniformity =       0;    %1D histo for 10 subsets of data
Plots.Snapback =                 0;		%Snapback !! NOT WORKING PROPERLY !!
Plots.SidebySide1D2D =        	0;		%Side by side 2D and 1D histo
Plots.dGvsG =                    0;    %Plots 

RedoHisto = 0;	%
Offset = 1;	% Offset correction of the data	!!WARNING!! This cannot be changed when loading a .mat file
Bias_offset=0 ;  % Bias offset 14mV on the piezo set up (Fixed by Nov 6th 2017)
Purge = 1;	% Remove traces with noise level above Purge_limit?
Purge_limit = 5e-6;	%	Traces with an offset higher than this will be removed from the data set
Restricted = 0; % Plot only a restricted subset of the data
G0_restricted=0; % Plot only traces with G_0 length >G0L
G0L= 0.025 ; %nm  Set threshold for G0 length
Load = 0;	% Load a previus workspace, if present?
Save = 1;	% Save plots?
Close = 1;	% Close individual traces after saving them
savepath = [path filename '/'];

% mkdir moved after the check for the existence of the files
% if Save & ~exist(savepath,'dir')
% 	mkdir(savepath);
% end

%% Parameters
Vtodconversion = 0.3e-6;      % 1000V = 300um
attenuation = 0.03/300; %5e-5; %15e-5;  % attenuation factor		!!WARNING!! This cannot be changed when loading a .mat file
noiselvl = 1e-12;

% load('color1.mat')	%Loads custom colormap used for 2D histo
camp=flip(magma());
if Restricted
    plotstart = 800;
    plotend = 1300;
    Nplotted = plotend-plotstart+1; %number of traces plotted
end

% Xmin = -0.5; %nm
% Xmax = 1.5; %nm
% Xbin = 310;
% Ymin = -7; %log10(5e-7); % for 5e-8 use Gmin = log10(5e-8);	-8
% Ymax = 1;
% binsperY = 30; %49;	%30
% Ybin = round((Ymax-Ymin)*binsperY);

Xmin = -0.5; %nm											%used for making histograms
Xmax = 3.5; %nm											%used for making histograms
binsperX =53.0;%75.5;%72.5;%37.75;%60.5;% 75.5;%72.5;;%66.75;%74.00;%83.25;%75.5;%90.75;%95.25; %76.91; %84.83; %63.67;%79.5; %46.5;%69.25;%37.75  38(0.04) ,43.25(0.035) 		%used for making histograms
Xbin = round((Xmax-Xmin)*binsperX);					%used for making histograms
Ymin = -6.8; %log10(5e-7); % log10(G0)				%used for making histograms
Ymax = 1; % log10(G0)									%used for making histograms
binsperY = 82;%30 ;									%used for making histograms
Ybin = round((Ymax-Ymin)*binsperY);					%used for making histograms
Dmin = -0.5; %nm											%displayed in plots
Dmax = 3.5; %nm											%displayed in plots
Gmin = 3e-7; % G0											%displayed in plots
Gmax = 3;	% G0											%displayed in plots
%OptimizeBinning2(G,hist2D) % Run this function to optimize Dbin

xedges = linspace(Xmin,Xmax,Xbin);
yedges = 10.^linspace(Ymin,Ymax,Ybin);
hist2D = zeros(Ybin,Xbin);
hist1D = zeros(Ybin,1);

%% check if directory and files are there
if ~exist(path,'dir')
    disp('Folder not found')
    return
else
    if ~exist([path filename '_1.dat'],'file') && ~Load
        disp('Files not found')
        return
    elseif ~exist([savepath filename '.mat'], 'file') && Load
        disp('.mat file not found')
        return
    else
        if Save && ~exist(savepath,'dir')
            mkdir(savepath);
        end
        
    end
end

%% Load workspace or work the files
if Load && exist([savepath filename '.mat'], 'file')
    if ~RedoHisto
        %	load([path filename '.mat'], '-regexp', '^(?!path$|savepath$).') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
        load([savepath filename '.mat'], '-regexp', '^(?!path$|savepath$|Save$|Load$|RedoHisto$|Plots$).') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
        disp(['Loading data file ' filename '.mat']);
        disp([num2str(Nfiles) ' trace(s) found'])
    else
        %	load([path filename '.mat'], 'attenuation','G','motor','Nfiles','piezo','settings','set_voltage','speed') ;	% Does not load path and savepath in case it's loading from a different computer. To omit anothoer variable add |VARIABLE$
        load([savepath filename '.mat'], 'attenuation','G','motor','Nfiles','Offset','piezo','settings','set_voltage','set_voltage_corrected','speed') ;	% Only loads the sepcified variables
        disp(['Loading data file ' filename '.mat']);
        disp([num2str(Nfiles) ' trace(s) found']);
        disp('Making new histograms');
        %{
		%Doesn't work because 'settings' is missing
		% Converting G from cell to struct for compatibility with old data sets
		if  iscell(G)
			tmp = G;
			clear('G');
			G(Nfiles) = struct('t_breaking',[],'d_breaking',[],'g_breaking',[],'t_making',[],'d_making',[],'g_making',[]);
			for i=1:Nfiles
				G(i) = tmp{i};
			end
			settings = ' ';
			piezo = 1;
			motor = 0;
		end
        %}
    end
elseif Nfiles == 0
    %% check number of runs
    if exist([path filename '_0.dat'],'file')
        counter = 0;
        k = 0;
    else
        counter = 1;
        k = 1;	% If the starting file is _1 and not _0, Nfiles = counter-1
    end
    
    while exist([path filename '_' num2str(counter) '.dat'],'file')
        counter = counter+1;
    end
    Nfiles = counter - k; %when exist fails, the loop ends and counter is not increased
    disp([num2str(Nfiles) ' file(s) found'])
    
    %% Get piezo/motor speed
    fid = fopen(strcat(path,filename,'_',num2str(k),'.dat'));
    filecontent = textscan(fid,'%s','delimiter','\n');
    filecontent = filecontent{:};
    startline = find(strncmp('@',filecontent,1));
    settings = filecontent(1:startline(1)-1);
    settings = regexprep(settings,'G0','G_0');
    %settings = char(settings);	% Not used anymore, so we can search
    %settings instead of filecontent
    piezoline = find(strncmp('Breaking speed 2', settings,16));
    motorline = find(strncmp('motor speed', settings,11));
    voltageline = find(strncmp('set voltage', settings,11));
    fclose(fid);
    
    if ~isempty(piezoline)
        piezo = 1;
        motor = 0;
        str = char(filecontent(piezoline));
        piezo_speed = sscanf(str,'Breaking speed 2 : %f');	% in V/s
        speed = piezo_speed*Vtodconversion;	% in m/s
        fprintf('Piezo speed found: %1.2f V/s\n',piezo_speed);
        str = char(filecontent(piezoline+1));
        making_speed = sscanf(str,'Making speed : %f');	% in V/s
        making_speed = making_speed*Vtodconversion;	% in m/s
    elseif ~isempty(motorline)
        motor = 1;
        piezo = 0;
        str = char(filecontent(motorline));
        motor_speed = sscanf(str,'motor speed : %f');	% in um/s
        speed = motor_speed * 1e-6;	% in m/s
        fprintf('Motor speed found: %1.2f um/s\n',motor_speed);
        making_speed = speed;
    else
        disp('File format not recognized (Not a breaking trace)')
    end
    
    try
        samplingline = find(strncmp('sampling rate', settings,13));
        str = char(settings(samplingline));
        sampling_rate = sscanf(str,'sampling rate = %f');	% in Hz
        points_per_nm = sampling_rate/(speed*attenuation*1e9);
    catch err
    end
    
    str = char(settings(voltageline));
    set_voltage = sscanf(str,'set voltage : %f');	% in V
    if Bias_offset
        set_voltage_corrected = set_voltage-.014;  % Fixing the bias offset
    else
        set_voltage_corrected = set_voltage;
    end
    fprintf('Set voltage found: %1.3f V\n',set_voltage_corrected);
    
    %% Importing data & Processing
    disp('Reading data...'); % Otherwise it reads the data files
    G(Nfiles) = struct('t_breaking',[],'d_breaking',[],'g_breaking',[],'t_making',[],'d_making',[],'g_making',[]);
    for i = 1:Nfiles
%         disp(strcat(num2str(i),'/',num2str(Nfiles)))
        %Reads the whole file as a string and puts it into filecontent
        fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));	%if the starting file is _0, k=0 and i-1+k=0; if it's _1, k=1 and i-1+k=1
        filecontent = textscan(fid,'%s','delimiter','\n');
        filecontent = filecontent{:};
        %Gets the position of the character @
        startline = find(strncmp('@',filecontent,1));
        fclose(fid);
        tmp=regexp(filecontent(startline(1)+1),'\s*([\S]*)\s*');	% looks for whitespace(s) non-whitespace(s) (and separates them in bloc whitespace(s)
        cols = numel(tmp{1});	% number of columns in the file
        
        % Import breaking trace
        fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));
        if cols == 2
            data = textscan(fid,'%f %f','HeaderLines',startline(1)+1);  % Look for the pattern 'float float' skipping the startline+1 lines at the beginning of the file (headerlines)
        else
            data = textscan(fid,'%f %f %f','HeaderLines',startline(1)+1);  % Look for the pattern 'float float float' skipping the startline+1 lines at the beginning of the file (headerlines)
        end
        fclose(fid);
        
        % Creates struct for breaking data
        G(i).t_breaking = data{1};
        G(i).d_breaking = G(i).t_breaking*speed*attenuation*1e9; % data file has time as x and it is here converted to displacement in nm (1e9 is for using nm)
        G(i).g_breaking = data{2} * set_voltage / (set_voltage_corrected); % S4c offset correction
        
        % Offset correction
        if Offset ==1
            offset = mean(G(i).g_breaking(end-45:end-5)); % calculates the offset with 200 points
            if Purge && offset > Purge_limit    % Discards traces that don't reach the noise level
                G(i).g_breaking(:) = noiselvl;
            else
                G(i).g_breaking = G(i).g_breaking-offset;
                G(i).g_breaking(G(i).g_breaking<noiselvl) = noiselvl;
            end
        else
            G(i).g_breaking = abs(G(i).g_breaking);
		  end
		  

        %Discard traces with G0 length > G0L defined in the beginning
        if G0_restricted==1
            G0_end=find(G(i).g_breaking<3e-1,1,'first');
            G0_start=find(G(i).g_breaking>10^0.15,1,'last');
            G0_point=G0_end-G0_start;
            Distance =G(i).d_breaking;
            D_per_point=(Distance(length(Distance))-Distance(1))/length(Distance);
            G0_length= G0_point * D_per_point;
            if G0_length<G0L
                G(i).g_breaking(:) = noiselvl;
            end
            
        end
        
        
        % Import making trace
        fid = fopen(strcat(path,filename,'_',num2str(i-1+k),'.dat'));
        data = textscan(fid,'%f %f','HeaderLines',startline(2)+1);
        %		data = textscan(fid,'%f %f %f','HeaderLines',startline(2)+1);
        fclose(fid);
        
        % Creates struct for making data %
        G(i).t_making = data{1};
        G(i).d_making = G(i).t_making*making_speed*attenuation*1e9; % data file has time as x and it is here converted to displacement in nm (motor speed = 4um/s, attenuation = 8e-5, 1e9 is for using nm)
        G(i).g_making = data{2} * set_voltage / (set_voltage_corrected); % S4c offset correction
        
        % Offset correction
        if Offset
            G(i).g_making = G(i).g_making-offset;
            G(i).g_making(G(i).g_making<noiselvl) = noiselvl;
            G(i).g_making = real(log10(abs(G(i).g_making)));
        end
    end
end

if ~Restricted
    plotstart = 1;
    plotend = Nfiles;
    Nplotted = Nfiles; %number of traces plotted
end

%% Breaking traces alignement & histo creation (done if a mat file is not loaded or by turning on RedoHisto = True)
if ~Load || (Load && RedoHisto)
    trace_hist = zeros(Ybin,Nfiles);
    disp(['Histograms include traces from ' num2str(plotstart) ' to ' num2str(plotend)])
    for i = 1:Nfiles
        try
            ind = find(G(i).g_breaking>3e-1,1,'last'); % zero displacement at run
            d0 = G(i).d_breaking(max(ind)); % finds the position for which G>0.3G_0 for the last time
            G(i).d_breaking = G(i).d_breaking-d0;   % shifts displacement so that it is 0 when G = 1G_0
            
            %Creating 1D histo for individual traces (used in JunctionEvolution,
            %correlation histo, tunneling removal and subsets check)
            trace_hist(:,i) = sum(hist2(G(i).d_breaking,G(i).g_breaking, xedges, yedges),2);
        catch err
        end
    end
    
    for i = plotstart:plotend
        %Creating 2D histo
        hist2D = hist2D + hist2(G(i).d_breaking,G(i).g_breaking, xedges, yedges);
    end
    
    %Creating 1D histo
    hist1D = sum(hist2D,2);
    
    %Normalizing them both
    hist1D = hist1D/Nplotted;
    hist2D = hist2D/Nplotted;
    
end

%% Saving workspace
%{
% Only sensible variables are saved, otherwise it's impossible to save or show other plots because loading the workspace overrides the settings
if exist('settings','var')
    save([path filename '.mat'], 'attenuation','Dbin','Dmax','Dmin','filename','G','Gbin','Gmax','Gmin','hist1D','hist2D','Nfiles','Nplotted','noiselvl','Offset','plotend','plotstart','set_voltage','settings','speed','Vtodconversion')	% saves selected variables in the folder with the raw data
else
    save([path filename '.mat'], 'attenuation','Dbin','Dmax','Dmin','filename','G','Gbin','Gmax','Gmin','hist1D','hist2D','Nfiles','Nplotted','noiselvl','Offset','plotend','plotstart','set_voltage','speed','Vtodconversion')	% saves selected variables in the folder with the raw data
    settings=[];
end
%}
if Save
    disp('Saving workspace')
    %	save([savepath filename '_' sprintf('%1.1f',set_voltage) 'V_' sprintf('%1.1f',speed*1e6) 'um_s.mat'])	% saves the whole workspace in the folder with the plots (not the one loaded)
    save([savepath filename '.mat'], '-v7.3')	% saves the whole workspace in the folder with the plots (not the one loaded)
end


%% One-look sum up
if Plots.SumUp ~= 0
    disp ('Plotting sum up');
    %	h=figure('PaperPosition',[0.6350 6.3500 20.3200 15.2400]);
    h=figure('PaperPositionMode','auto','Position',[150 100 1600 850]);
    h1=subplot(2,3,[1 4]);
    set(h1,'Position',[0.07 0.1 0.23 0.85])
    %plot_2DHist(hist2D);
    plot_2DHist_2(hist2D,'out',Dmin,Dmax,Gmin,Gmax);
    h2=subplot(2,3,2);
    plot_1DHist(hist1D);
    set(h2,'Position',[0.425 0.6 0.25 0.35])
    h3=subplot(2,3,5);
    set(h3,'Position',[0.425 0.11 0.25 0.35])
    plot_Junction_evo(trace_hist);
    v = [0 min(yedges); plotstart min(yedges); plotstart max(yedges); 0 max(xedges); plotend min(yedges); Nfiles min(yedges); Nfiles max(yedges); plotend max(xedges)];
    f = [1 2 3 4
        5 6 7 8];
    patch('Faces',f,'Vertices',v,'EdgeColor','none','FaceColor',[0.5 0.5 0.5],'FaceAlpha',.6);
    line([plotstart plotstart],ylim, 'Color','g');
    line([plotend plotend],ylim, 'Color','g');
    h4=subplot(2,3,[3 6]);
    set(gca,'visible','off');	%removes axis
    str = char(filename);
    str = strrep(str,'_','\_');	% prevents the underscore from being interpreted as subscript
    info = {['Data set: ' str],['Date: ' str(9:10) '/' str(7:8) '/' str(5:6)],[num2str(Nfiles) ' traces'],'',...
        char(settings),...
        '',...
        ['Attenuation: ' sprintf('%1.1e',attenuation)],...
        ['Plotted range: ' num2str(plotstart) '-' num2str(plotend)],...
        ['Offset correction: ' num2str(Offset)],...
        '',...
        sprintf('Dbin: %i',Xbin),...
        sprintf('binsperG: %i',binsperY),...
        %	sprintf('Gbin: %i',Gbin),...
        %		'Notes: Bare Au',...
        };
    
    % Adds the "Points per nm: " line after "Attenuation: "
    if exist('sampling_rate','var')
        idx = find(ismember(info, ['Attenuation: ' sprintf('%1.1e',attenuation)]));
        for i = numel(info):-1:idx-1
            info{i+1} = info{i};
        end
        info{idx-1} = (['Points per nm: ' sprintf('%1.1f',points_per_nm)]);
    end
    
    set(gcf,'Position',[150 100 1600 850])
    set(findall(gcf,'type','text'),'fontsize',17,'fontweight','normal')
        annotation('textbox',[0.75 0.11 0.20 0.85],...
        'String',info,...
        'FontSize',13,...
        'FontName','Arial',...
        'BackgroundColor',[1 1 1],...
        'Tag' , 'somethingUnique');
    drawnow()
    if Save == 1
        if piezo
            if ~exist('piezo_speed','var')
                piezo_speed = sscanf(char(settings(7,:)),'Breaking speed 2 : %f');
            end
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_[' num2str(plotstart) '-' num2str(plotend) ']_advanced.png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_advanced.png'])
            end
        end
        if motor
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_[' num2str(plotstart) '-' num2str(plotend) ']_advanced.png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_advanced.png'])
            end
        end
    end
    
    %# delete the annotation
    delete(findall(gcf,'Tag','somethingUnique'))
    
    info = {['Data set: ' str],['Date: ' str(9:10) '/' str(7:8) '/' str(5:6)],[num2str(Nfiles) ' traces'],'',...
        ['Attenuation: ' sprintf('%1.1e',attenuation)],...
        ['Traces plotted: ' num2str(plotstart) '-' num2str(plotend)],...
        ['Bias V: ' sprintf('%1.3f',set_voltage_corrected) ' V'],...
        ['Piezo Speed: ' sprintf('%1.1f',speed/Vtodconversion) ' V/s'],...
        ['Electrode Speed: ' sprintf('%1.1f',speed*attenuation*1e9) ' nm/s'],...
        %['Sampling Rate: ' sprintf('%1.1f',sampling_rate) ' Hz'],...
        %		'Notes: Bare Au',...
        };
    annotation('textbox',...
        [0.75 0.11 0.20 0.85],...
        'String',info,...
        'FontSize',14,...
        'FontName','Arial',...
        'BackgroundColor',[1  1 1],...
        'Tag' , 'somethingUnique');
    
    set(gcf,'Position',[150 100 1600 850])
    set(findall(gcf,'type','text'),'fontsize',17,'fontweight','normal')
    if Save == 1
        if piezo
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',piezo_speed) 'V_s.png'])
            end
        end
        if motor
            if Restricted
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            else
                saveas(h,[savepath filename '_' sprintf('%1.3f',set_voltage_corrected) 'V_' sprintf('%1.1f',motor_speed) 'um_s.png'])
            end
        end
    end
end
%}

%% 1D histogram
if Plots.Hist1D == 1
    disp('Plotting 1D Histogram');
    
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');
    plot_1DHist(hist1D);
    set(gca,'Fontsize',28,'Linewidth',2.0)
    
    %  	pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
    %  	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    %  	MAX = max(hist1D(pos2:pos1));
    %
    % 	h = figure;
    % 	semilogx(yedges,hist1D);
    % 	xlabel('Conductance [G_0]')
    % 	ylabel('Counts/trace')
    % 	set(gca,'fontsize',20,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    % 	set(gca,'linewidth',1.5,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[10^Gmin  3])
    % 	set(gca,'Ylim',[0 1.05*MAX])
    % 	set(gca,'XTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	%set(gca,'XTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_G_1D_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_G_1D_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_G_1D.png'])
            saveas(h,[savepath filename '_G_1D.fig'])
        end
    end
    
end

%% 2D histogram
if Plots.Hist2D == 1
    disp('Plotting 2D Histogram');
    
    % 	h = figure('Position',[50 150 600 850],'PaperPositionMode','auto');
    % 	axes('Position',[0.17 0.11 0.62 0.815]);
    %h = figure('Position',[500 150 600 800],'PaperPositionMode','auto');
    %axes('Position',[0.17 0.11 0.72 0.815]);
    %plot_2DHist_2(hist2D,'north',Dmin,Dmax,Gmin,Gmax);
    %plot_2DHist_2(hist2D,'east',Dmin,Dmax,Gmin,Gmax);
    
    h = figure('Position',[500 150 600 750],'PaperPosition',[0.6 5 16 20],'PaperPositionMode','auto');
    plot_2DHist_2(hist2D,[],Dmin,Dmax,Gmin,Gmax);
    set(gca,'Fontsize',24,'Linewidth',2.0)
    
    % 	%Normalize histogram so that the best constrast is between 1e-3 and 1e-6
    % 	pos1 = find(min(abs(yedges - 1e-3)) == abs(yedges - 1e-3));
    % 	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    % 	MAX = max(max(hist2D(pos2:pos1,:)))/2;
    %
    % 	h = figure('PaperPosition',[0.6 5 16 20]);
    % 	%surf(xedges,yedges,hist2D,'edgecolor','none');
    %   	surf(xedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
    % 	view([0 90])
    % 	% axis([-0.5,2,10.^-6.1,10.^0.5]) %2D histo
    % 	c=colorbar;%('Position',[0.915 0.16 0.03 0.7]);
    % 	title(c,'Counts/trace')
    % 	set(gca,'YScale','log')
    % 	xlabel('Electrode displacement [nm]')
    % 	ylabel('Conductance [G_0]')
    % 	%title('Bare Au')
    % 	set(gca,'fontsize',20,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    % 	set(gca,'linewidth',2,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[-0.5 2])
    % 	set(gca,'Ylim',[10^Gmin 3])
    % 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	%set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    % 	set(gca,'Tickdir','in')
    % 	set(gcf,'Position',[500 150 600 750])
    % 	colormap(cmap)
    % 	caxis([0 MAX])
    %     ch = get(c,'YLabel'); % Handle of the x label
    %     %pause(0.2)	% If I remove this the colorbar comes out wrong...
    %     colormap(c,cmap)	%... so I have to reset it
    %     set(ch, 'Units', 'Normalized')
    %     %pos = get(ch, 'Position');
    %     set(ch,'Position',[2.75 0.5])	% These values were based on the pos of the line above
    
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_G_2D_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_G_2D_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_G_2D.png'])
            saveas(h,[savepath filename '_G_2D.fig'])
        end
    end
    
end

%% Junction evolution
if Plots.JunctionEvolution == 1
    disp('Plotting junction evolution');
    
    f = figure('Position',[450 150 1100 775],'PaperPositionMode','auto');
    plot_Junction_evo(trace_hist);
    
    
    % 	tracenum = 1:Nfiles;
    %
    % %JunctionEvolution is obsolete, trace_hist is ideally identical to JunctionEvolution (small
    % % differences due to the different filling method)
    % %	JunctionEvolution = zeros(Gbin,Nfiles);
    % %	for i = 1:Nfiles
    % %		JunctionEvolution(:,i) = hist(G(i).g_breaking,yedges);
    % %	end
    
    % % Convert any 1D histo in a paper-ready figure
    % 	pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
    %  	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    %  	MAX = max(max(trace_hist(pos2:pos1,:)));
    %
    % 	h = figure;
    % 	surf(tracenum,yedges,trace_hist,'LineStyle','none');	% 'LineStyle','none' removes the grid over which the surface is plotted, preventing the plot to show as all black when too dense
    % 	set(gca,'YScale','log')
    % 	view([0 90])
    % 	xlabel('Trace number');
    % 	ylabel('Conductance [G_0]');
    % 	set(gca,'fontsize',22,'fontweight','normal')
    % 	set(findall(gcf,'type','text'),'fontsize',22,'fontweight','normal')
    % 	set(gca,'linewidth',0.5,'box','on')
    % 	set(gcf,'color','white')
    % 	set(gca,'Xlim',[1 Nfiles])
    % 	set(gca,'Ylim',[10^Gmin 3])
    % 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
    % 	set(gca,'Tickdir','in')
    % 	%colormap(linspecer)
    % 	%colormap(cmap)
    % 	c=colorbar;
    % 	ylabel(c,'Counts/trace')
    % 	caxis([0 0.5*MAX])
    
    if Save == 1
        saveas(f,[savepath filename '_Junction_evo.png'])
        saveas(f,[savepath filename '_Junction_evo.fig'])
    end
    
    %Two vertical green lines show the traces included in the histograms
    line([plotstart plotstart],ylim, 'Color','g');
    line([plotend plotend],ylim, 'Color','g');
    
    
end

%% 1G_0 length histogram plotstart and plotend %MODIFY THE PROGRAM SO THAT ATTENUATION CHANGES TO HAVE THE BIGGEST BIN ON 0.25nm
if Plots.G0Length == 1
    disp('Plotting 1G_0 length');
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');
    Fit_Length_1G0(G,Nplotted,plotstart,plotend,Xmax,Xmin,Xbin)
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_1G0_length_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_1G0_length_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_1G0_length.png'])
            saveas(h,[savepath filename '_1G0_length.fig'])
        end
    end
    
end

%% Total length
if Plots.TotalLength == 1
    disp('Plotting total length');
    Length = zeros(1,Nplotted);
    for i = plotstart:plotend
        if ((max(G(i).g_breaking))>0.5) % && IsMol(i)==1
            xstart = find((G(i).g_breaking)<3e-1,1,'first');
            xend = find((G(i).g_breaking)>20e-7,1,'last');
            
            Length(i) = G(i).d_breaking(xend)-G(i).d_breaking(xstart);
        end
    end
    
    %			figure;
    % 			plot_single_trace(i);
    % 			hold on;
    % 			line([G(i).d_breaking(xstart) G(i).d_breaking(xstart)],ylim,'Color','g');
    % 			line([G(i).d_breaking(xend) G(i).d_breaking(xend)],ylim,'Color','r');
    
    %	selected_Length = find(Length>0.5);
    
    Lengthbins = linspace(0,5,60);
    Lengthhisto = hist(Length,Lengthbins);
    Lengthhisto = Lengthhisto / Nplotted;
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');	%Opens new window where to plot
    %subplot(2,2,4)      %Plots in panel 4 of the subplot
    bar(Lengthbins,Lengthhisto,'Facecolor',[0.6445,0.8008,0.5352]);
    title('Total Length')
    ylabel('Counts/trace');
    xlabel('Length [nm]');
    set(gca,'Xlim',[0.05 5])
    set(gca,'Ylim',[0 1.05*max(Lengthhisto)])
    set(gca,'fontsize',20,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',15,'fontweight','normal')
    set(gca,'linewidth',2,'box','on')
    set(gcf,'color','white')
    set(gca,'Tickdir','in')
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_total_length_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_total_length_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_total_length.png'])
            saveas(h,[savepath filename '_total_length.fig'])
        end
    end
    
end

%% Tunnel slope
if Plots.Tunnelslope == 1
    disp('Plotting Tunneling Slope');
    Length = zeros(1,Nplotted);
    TSlope=zeros(1,Nplotted);
    for i = plotstart:plotend
        if ((max(G(i).g_breaking))>0.5) % && IsMol(i)==1
            xstart = find((G(i).g_breaking)<1e-5,1,'first'); % The starting and ending for slope calculation
            xend = find((G(i).g_breaking)>1e-6,1,'last');
            
            Length(i) = G(i).d_breaking(xend)-G(i).d_breaking(xstart);
            TSlope(i)= (log10(1e-5) -log10(1e-6))/Length(i);
        end
    end
    
    %			figure;
    % 			plot_single_trace(i);
    % 			hold on;
    % 			line([G(i).d_breaking(xstart) G(i).d_breaking(xstart)],ylim,'Color','g');
    % 			line([G(i).d_breaking(xend) G(i).d_breaking(xend)],ylim,'Color','r');
    
    %	selected_Length = find(Length>0.5);
    
    TSlopebins = linspace(0,15,60);
    TSlopehisto = hist(TSlope,TSlopebins);
    TSlopehisto = TSlopehisto / Nplotted;
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');	%Opens new window where to plot
    %subplot(2,2,4)      %Plots in panel 4 of the subplot
    bar(TSlopebins,TSlopehisto,'Facecolor',[0.6445,0.8008,0.5352]);
    title('Tunneling Slope')
    ylabel('Counts/trace');
    xlabel('Slope [dec/nm]');
    set(gca,'Xlim',[0 15])
    set(gca,'Ylim',[0 1.05*max(TSlopehisto(2:end))])
    set(gca,'fontsize',20,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',15,'fontweight','normal')
    set(gca,'linewidth',2,'box','on')
    set(gcf,'color','white')
    set(gca,'Tickdir','in')
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_Tunnel_slope_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_Tunnel_slope_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_Tunnel_slope_.png'])
            saveas(h,[savepath filename '_Tunnel_slope_.fig'])
        end
    end
    
end

%% Correlation histogram (as in P. Makk et al., ACSNANO vol 6 No 4)
% Plots.CorrelationHisto = 1;
if Plots.CorrelationHisto == 1
    disp('Plotting correlation histogram');
    corr = zeros(Ybin,Ybin);
    norm = zeros(Ybin,1);
    %Creating covariance histogram
    for i=plotstart:plotend
        %		trace_hist(:,i) = sum(hist2(G(i).d_breaking,G(i).g_breaking, xedges, yedges),2);
        %		trace_hist(:,i) = JunctionEvolution(i,:)';
        corr = corr + trace_hist(:,i)*trace_hist(:,i)';
        norm = norm + (trace_hist(:,i)-hist1D).^2;
    end
    %hist1D represents <Ni>r, (1) in the reference
    corr = corr/Nplotted-(hist1D*hist1D');	%now corr is equal to <Ni*Nj>r - <Ni>r * <Nj>r, (3) in the reference
    
    %Normalizing covariance histo to obtain the correlation histo
    norm = norm/Nplotted;
    corr = corr./sqrt(norm*norm');
    
    % Just 2DCH
    %{
% 	h = figure('PaperPosition',[0.6 5 20 20]);
% 	%surf(xedges,yedges,hist2D,'edgecolor','none');
%   	surf(yedges,yedges,corr,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
% 	view([0 90])
% 	% axis([-0.5,2,10.^-6.1,10.^0.5]) %2D histo
% 	c=colorbar;
% 	%ylabel(c,'Counts per trace')
% 	set(gca,'XScale','log')
% 	set(gca,'YScale','log')
% 	xlabel('G_i [G_0]')
% 	ylabel('G_j [G_0]')
% 	set(gca,'fontsize',20,'fontweight','normal')
% 	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
% 	set(gca,'linewidth',2,'box','on')
% 	set(gcf,'color','white')
% 	set(gca,'Xlim',[10^Gmin 3])
% 	set(gca,'Ylim',[10^Gmin 3])
% 	set(gca,'XTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
% 	set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
% 	set(gca,'Tickdir','in')
% 	set(gcf,'Position',[500 150 750 750])
% 	colormap(brewermap([],'*RdBu'));
% 	caxis([-1 1])
	
% 	expG = 2e-5;
% 	expG = find(min(abs(yedges-expG)) == abs(yedges-expG));
% 	%Lines that show where the conductance peaks are
% 	line([expG expG],ylim, 'Color','g','linewidth',2);
% 	line(xlim,[expG expG], 'Color','g','linewidth',2);
    %}
    
    % 1D histo and 2DCH side by side
    h=figure;
    
    %1D histogram
    pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
    pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
    MAX = max(max(hist1D(pos2:pos1)));
    
    h1=subplot(1,2,1);
    semilogy(hist1D, yedges);
    xlabel('Counts per trace')
    ylabel('G_i [G_0]')
    set(gca,'fontsize',20,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    set(gca,'linewidth',0.5,'box','on')
    set(gcf,'color','white')
    set(gca,'Ylim',[10^Ymin  3])
    set(gca,'Xlim',[0 1.05*MAX])
    set(gca,'YTick',10.^linspace(Ymin,Ymax,Ymax-Ymin+1))
    
    
    %2DCH
    h2=subplot(1,2,2);
    surf(yedges,yedges,corr,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
    view([0 90])
    % axis([-0.5,2,10.^-6.1,10.^0.5]) %2D histo
    c=colorbar;
    %ylabel(c,'Counts per trace')
    set(gca,'XScale','log')
    set(gca,'YScale','log')
    xlabel('G_j [G_0]')
    ylabel('')
    set(gca,'fontsize',20,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    set(gca,'linewidth',0.5,'box','on')
    set(gcf,'color','white')
    set(gca,'Xlim',[10^Ymin 3])
    set(gca,'Ylim',[10^Ymin 3])
    set(gca,'XTick',10.^linspace(Ymin,Ymax,Ymax-Ymin+1))
    set(gca,'YTick',10.^linspace(Ymin,Ymax,Ymax-Ymin+1))
    set(gca,'Tickdir','in','YTickLabel','')
    colormap(brewermap([],'*RdBu'));
    caxis([-0.3 0.5])
    title(h2,'2DCH');
    
    
    %	axis square		% should ensure that the axis have the same lentgh
    %	pbaspect([1 1 1])		%should control the aspect ratio of the plot...
    set(h,'Position', [240, 200, 1100, 750])
    set(h1,'Position', [0.1300, 0.1160, 0.15, 0.8090])
    pos = get(h1,'position');
    set(h2,'Position', [pos(1)+pos(3), pos(2), pos(4)*42/56, pos(4)])
    pos = get(h2,'position');
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_2DCH_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_2DCH_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_2DCH.png'])
            saveas(h,[savepath filename '_2DCH.fig'])
        end
    end
end

%% Tunneling removal
%Plots.TunnelingRemoval = 1;
if Plots.TunnelingRemoval
    %    disp('Plotting tunneling removal histogram');
    [Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection(G,trace_hist,hist2D);
end


%}

%% Conductance Selection (Conditional histogram)
%Plots.ConductanceSelection=1;
%[Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection(G,trace_hist,hist2D,2e-5,4e-4,2);

if Plots.ConductanceSelection
    disp('Plotting conductance selection');
    %	[Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection(G,trace_hist,hist2D);
    [Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection(G,trace_hist,hist2D,1e-6,1e-4,1.0);
    %	[Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection2(G,hist1D,0.7,3e-6,1e-6,3);
    %	[Nmol,Nempty,hist1D_mol,hist1D_empty,hist2D_mol,hist2D_empty,IsMol] = ConductanceSelection(G,trace_hist,hist2D,2.5e-4,1e-1,1.0);
    
    if Restricted
        % We have worked with reduced variable so far, but trace_hist
        % contains all traecs (not only the restriced set) so we have to make
        % sure we take that into account when we create histograms and spit
        % out IsMol to the main program
        IsMol = logical([zeros(1,plotstart-1) IsMol zeros(1,length(trace_hist)-plotend)]);
    end
    
    %Bar plot of the 1D histogram
    %{
	g=figure('PaperPositionMode','auto');
	bar(log10(yedges),hist1D);
	set(gca,'Xlim',[-6 -2]);
	xlabel('log(Conductance [G_0])');
	ylabel('Counts/trace');
	set(gca,'Ylim',[0 2]);
	saveas(g,[savepath filename '_1D_bar.png'])
	saveas(g,[savepath filename '_1D_bar.eps'])

	g=figure('PaperPositionMode','auto');
	bar(log10(yedges),hist1D_mol);
	set(gca,'Xlim',[-6 -2]);
	xlabel('log(Conductance [G_0])');
	ylabel('Counts/trace');
	%set(gca,'Ylim',[0 2]);
	saveas(g,[savepath filename '_1D_bar_filtered.png'])
	saveas(g,[savepath filename '_1D_bar_filtered.eps'])

	%g = figure;
	%plot_1DHist(hist1D_mol);
	%saveas(g,[savepath filename '_1D_filtered_only.png'])
    %}
end

%% Auto Covariance Plots
if (Plots.Autocovariance == 1)
    disp('Plotting 2D histo with tunneling removal');
    Plot_AutoCovariance_Peak([plotstart : plotend],G)
	 Plot_AutoCovariance_Sum([plotstart : plotend],G)
end


%% Distance dependence (Plot with length control)

%histobetwLengthcontrol(hist2D);
%histobetwLengthcontrol(hist2D_mol);

%{
%This section shows the evolution of the 1D histogram across k regions
%0.25nm wide starting from x1
h = figure('PaperPosition',[0.6 5 16 20]);
plot_2DHist(hist2D);
%plot_2DHist(hist2D_mol);
	
for k=1:5	%Number of ranges over which you plotted
	x1 = 0.75 + (k-1)*0.25;	% starting_x + (k-1)*window_width
	figpos = dsxy2figxy([x1,0.7,0.25,1.15]);	%Transforms normalized units into data unit [x y width height] (some problems with the log y axis...)
%	[figx figy] = dsxy2figxy([x1,y1],[x2,y2]); %Transforms normalized units into data unit [x1 y1 x2 y2]
	a(k)=annotation('textbox',[figpos(1) figpos(2) figpos(3) figpos(4)],'String',num2str(k),'EdgeColor','k','FontSize',16);
	set(a(k),'HorizontalAlignment','center','VerticalAlignment','middle');
end
if Save
	if Restricted
		saveas(h,sprintf([savepath 'distance dependence/' filename '_[%i-%i]_2D_DistDep.png'],plotstart,plotend))
		saveas(h,sprintf([savepath 'distance dependence/' filename '_[%i-%i]_2D_DistDep.fig'],plotstart,plotend))
	else
		saveas(h,[savepath 'distance dependence/' filename '_2D_DistDep.png'])
		saveas(h,[savepath 'distance dependence/' filename '_2D_DistDep.fig'])
	end
end
close(h)

%}

%% Steepness Filter
%{
	SteepnessFilter(G(plotstart:plotend),hist2D,-0.75,0.1,0.1)
%}

%% Derivative
if Plots.dGvsG
    figure;
    semilogx(yedges(2:end),diff(hist1D));
    
    %    dG_breaking(i) = zeros(Nfiles);
    %    for i = plotstart:plotend
    %       dG_breaking(i) = diff(G(i).g_breaking);
    %
    %    end
    
    
end

%% Print sets of 10 random curves and select which ones you want to save
%randomplots(G);
%randomplots(G,IsMol);
%randomplots(G,IsSlope);

%{
if exist('h0','var') && ~isempty(h0) && ishandle(h0) %closes the random curves figure if one is open (needed to prevent conflicts)
    close(h0)
end
h0 = figure;
set(h0,'Name','Random traces');	% Names h0
set(h0,'KeyPressFcn',@KeyPress);	% Calls KeyPress whenever a key is pressed when h0 is the active figure
hObject = findobj('Name','Random traces');
handles = guidata(hObject);	% Creates a variables for the handles of hObject
handles.selected = [];	% Initialize variable in the handles
handles.quit = 0;
handles.next = 0;
guidata(hObject,handles)	% Updates handles of hObject
pool=(plotstart:plotend);	% Pool of numbers that can be extracted

while ~handles.quit
    r = datasample(pool(pool>0),10,'Replace',false);    % Extract 10 random numbers from the pool without replacement
    pool(r) = -1;	% Removes from the pool the numbers that were just extracted
    for iii = 1:10
        disp([num2str(iii) ': ' num2str(r(iii))]);
        h(iii)=subplot(2,5,iii);
        plot_single_trace(r(iii));
        set(h(iii), 'ButtonDownFcn', {'AddToSelected',r(iii)});	% Makes the subplots clickable and passes the number of the trace to AddToSelected
    end
    handles.next = 0;
    guidata(hObject,handles) % Updates handles of hObject (saves the updated handles.selected
    
    % Pressing an arrow exits the inner while loop and continues the outer
    % one, plotting 10 more traces. Pressing Q exits the inner loop and
    % breaks out of the outer loop. Pressing any other key does nothing.
    disp('Press Q to exit the loop, an arrow to go to the next 10 traces')
    while ~handles.next
        pause(0.001);
        hObject = findobj('Name','Random traces');
        handles = guidata(hObject);
        selected = handles.selected;
        selected = sort(unique(selected));
    end
end
close(h0);
%}

%iii = iii+1; semilogy(G(r(iii)).x,10.^G(r(iii)).y);

%% Plots individual traces from selection
% If you already know what to plot and don't need the above section, just
% write here the array of traces you want to plot and save

%selected =
%[18,23,29,30,35,36,46,62,75,77,78,85,92,150,184,189,204,422,439,444,452,473,518,709] % Peptide scan170221_8

% This whole section is skipped if there are no selected traces to plot/save
if exist('selected','var') && ~isempty(selected)
    print_single_traces(selected);
end

%
%Old version here
%{
	nend = numel(selected);
	for i = 1:nend
		h = figure('name',['Trace ' num2str(selected(i))],'NumberTitle','off','PaperPosition',[0.6 5 16 20]); %'NumberTitle','off' is used to remove the "Figure X" text
		subplot('position',[0.15 0.15 0.7 0.8])
		% set(gcf,'PaperPositionMode','auto')	% Forces the figure's size and location on the printed page to directly reflect the figure's size on the screen
		semilogy(G(selected(i)).d_breaking,G(selected(i)).g_breaking);
		set(gca,'Xlim',[-0.3 3]);
		set(gca,'Ylim',[1e-7 3]);
		set(gca,'YTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1]);
		set(gca,'Tickdir','in');
		ylabel('Conductance [G_0]');
		xlabel('Electrode displacement [nm]');
		set(gcf,'Position',[500 150 600 750]);
		
		if Save == 1
			if ~exist([savepath 'selected traces/'],'dir')
				mkdir([savepath 'selected traces/']);
			end
			
			saveas(h,[savepath 'selected traces/' filename '_trace' num2str(selected(i)) '.png'])
			saveas(h,[savepath 'selected traces/' filename '_trace' num2str(selected(i)) '.fig'])
			saveas(h,[savepath 'selected traces/' filename '_trace' num2str(selected(i)) '.svg'])
		end
		if Close
			close(h)
		end
		
	end
%}


%}

%% Plots a side by side plot of a few traces (2-6) to show as examples
%{
examples = [197,365,475,704,748,1177,1619];

%print_example_traces(examples)
print_example_traces(examples, G, 1.5, 1.3)
%}

%% Plots for paper
%	superimposed = [1021, 477, 898, 691];
%	plot_2DHist_paper(hist2D);
%	plot_2DHist_paper(hist2D,xedges,yedges,G,superimposed);

%% Side by side 2D and 1D histo plots
if Plots.SidebySide1D2D
    plot_1Dand2Dsidebyside(hist1D,hist2D)		% saves just a png
    %plot_1Dand2Dsidebyside(hist1D,hist2D,1)	% version with axis and 2D histo split for paper
end

%% Gaussian fit of 1D histogram
%signal = [log10(yedges)' hist1D];
%signal = [log10(yedges)' hist1D_mol];
%peakfit(signal,-4.8388,1.3293,2,1,3.58,10, [-5.2338     0.52946     -4.6465     0.62964], 0, [0], 1 ,0,0.020451,0.013293,4.6765)

% set(gcf,'position',[450 150 1100 775],'paperpositionmode','auto')
% hold on;
% plot(log10(yedges),hist1D,'Linewidth',1.5);
% plot(log10(yedges),hist1D_empty,'Color',[0.4660 0.6740 0.1880],'Linewidth',1.2);
%
% title('')
% xlabel('log_{10}(Conductance / G_0)')
% ylabel('Counts / trace')
% set(gca,'fontsize',20,'fontweight','normal')
% set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
% set(gca,'linewidth',0.5,'box','on')
% set(gcf,'color','white')
% set(gca,'Xlim',[Gmin  0.5])
% set(gca,'XTick',[-7 -6 -5 -4 -3 -2 -1 0])
%
% pos2 = find(min(abs(yedges - 3)) == abs(yedges - 3));
% pos1 = find(min(abs(yedges - 5e-6)) == abs(yedges - 5e-6));
% MAX = max([max(hist1D(pos1:pos2)),max(hist1D_mol(pos1:pos2)),max(hist1D_empty(pos1:pos2))]);
% set(gca,'Ylim',[0 1.05*MAX])
% l = legend('All',['Selected ' sprintf('%1.1f',Nmol/Nplotted*100) '%'],['Excluded ' sprintf('%1.1f',Nempty/Nplotted*100) '%']);
% set(l,'fontsize',20,'Location','best')

%% Gaussian fit of lentgh
%datamatrix = [Lengthbins' Lengthhisto'];
%datamatrix = [G0Lengthbins' G0Lengthhisto'];
%[FitResults,FitError]=peakfit(datamatrix,1.2712,0.67797,1,1,0.6,10, [1.1583     0.48795], 0, [0], 1 ,0,0.084746,0.0067797,0.1445)

%% Collective plot
%With this you can plot all (selected?) traces in the same figure
%{
figure;
plot_single_trace(G(1).d_breaking,G(1).g_breaking,1);
hold on;
%plot(G(IsMol).d_breaking,G(IsMol).g_breaking);
for i = 2:numel(G)
	plot(G(i).d_breaking,G(i).g_breaking);
end

figure;
plot_single_trace(selected(1));
hold on;
%plot(G(IsMol).d_breaking,G(IsMol).g_breaking);
for i = 2:numel(selected)
	h=plot(G(selected(i)).d_breaking,G(selected(i)).g_breaking,'Linewidth',2);
	title(i)
	waitforbuttonpress;
	set(h,'Linewidth',1);
end

%}

%% Junction formation probability (molecular junction separation)
%Plots.JFormationProb = 1;
if Plots.JFormationProb
    disp('Plotting junction formation probability')
    
    if ~exist('IsMol','var')
        IsMol = zeros(1,Nfiles);
        
        % Simple data selection: filters out empty junctions
        pos1 = find(min(abs(yedges-(1e-2))) == abs(yedges-(1e-2)));
        pos2 = find(min(abs(yedges-(1e-5))) == abs(yedges-(1e-5)));
        
        for i=1:Nfiles
            if sum(trace_hist(pos2:pos1,i)) > sum(hist1D(pos2:pos1))
                IsMol(i) = 1;
            end
        end
        Nmol = nnz(IsMol);
        
        %Plots that show which traces have been selected
        figure;
        plot(sum(trace_hist(pos2:pos1,:)),'.');
        hold on;
        line(xlim,[sum(hist1D(pos2:pos1)) sum(hist1D(pos2:pos1))], 'Color','g');
        xlabel('Trace number')
        ylabel('Counts in selected range')
        
    end
    
    separation = find(IsMol(plotstart:plotend)==1);
    separation = diff(separation);
    
    %Create statistics for first and second half of the data set
    separation1 = separation(1:round(numel(separation)/2));
    separation2 = separation(round(numel(separation)/2):end);
    
    separation = histcounts(separation,'Normalization','probability');
    separation1 = histcounts(separation1,'Normalization','probability');
    separation2 = histcounts(separation2,'Normalization','probability');
    
    %Theoretical binomial probability with	p = Nmol/Nfiles
    p = Nmol/Nplotted;
    prob_theo = zeros(1,numel(separation));
    for k = 1:numel(separation)
        prob_theo(k) = power((1-p),k-1) * p;
    end
    
    %Theoretical binomial probability with p = separation(1)
    p2 = separation(1);
    prob_theo2 = zeros(1,numel(separation));
    for k = 1:numel(separation)
        prob_theo2(k) = power((1-p2),k-1) * p2;
    end
    
    h=figure;
    hold on;
    set(gcf,'Position',[350 180 1100 790])
    bar(separation,2/3,'FaceColor',[0    0.4470    0.7410]);
    %    plot(prob_theo,'r.','Markersize',20);
    %   plot(prob_theo2,'.','Color',[0.2,0.6,0.2],'Markersize',20);
    plot(prob_theo,'.','Color',[0.8500   0.3250    0.0980],'Markersize',40);
    set(gca,'YScale','log')
    set(gca,'Xlim',[0.5 8.5])
    %set(gca,'Xlim',[0 numel(separation)+1])
    set(gca,'Ylim',[1e-3 1])
    set(gca,'XTick',(1:8))
    xlabel('Separation between molecular junctions')
    ylabel('Probability')
    %title('Bare Au')
    set(gca,'fontsize',18,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    set(gca,'linewidth',1,'box','on')
    set(gcf,'color','white')
    %    legend('Data','Ideal 1 (p=Nmol/Ntot)','Ideal 2 p=p(separation is 1)')
    %    legend('Data','Ideal 1 p(x)','Ideal 2 p(x|x-1=1)');
    legend('Data',sprintf('p = %1.2f',p));
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_Jformation_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_Jformation_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
            saveas(h,[savepath filename '_Jformation_[' num2str(plotstart) '-' num2str(plotend) '].eps'])
        else
            saveas(h,[savepath filename '_Jformation_.png'])
            saveas(h,[savepath filename '_Jformation_.fig'])
            saveas(h,[savepath filename '_Jformation_.eps'])
        end
    end
    %
    % 	 h=figure;
    %     set(gcf,'Position',[350 180 1100 790])
    %     hold on;
    %     bar(separation,0.9,'FaceColor',[0    0.4470    0.7410]);
    %     bar(separation1,2/3*0.9,'FaceColor',[0.8500    0.3250    0.0980]);
    %     bar(separation2,1/3*0.9,'FaceColor',[0.9290    0.6940    0.1250]);
    %     plot(prob_theo,'b.','Markersize',20);
    %     plot(prob_theo2,'k.','Markersize',20);
    %     set(gca,'YScale','log')
    %     set(gca,'Xlim',[0.5 8.5])
    % 	%set(gca,'Xlim',[0 numel(separation)+1])
    %     set(gca,'Ylim',[1e-3 1])
    %     set(gca,'XTick',(1:8))
    %     xlabel('Separation between molecular junctions')
    %     ylabel('Probability')
    %     %title('Bare Au')
    %     set(gca,'fontsize',18,'fontweight','normal')
    %     set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
    %     set(gca,'linewidth',1,'box','on')
    %     set(gcf,'color','white')
    % %    legend('Data','Data (first half)','Data (second half)','Ideal 1 (p=Nmol/Ntot)','Ideal 2 p=p(separation is 1)')
    %     legend('Data','Data (first half)','Data (second half)','Ideal 1 p(x)','Ideal 2 p(x|x-1=1)')
    %
    %     if Save == 1
    %         if Restricted
    %             saveas(h,[savepath filename '_Jformation2_[' num2str(plotstart) '-' num2str(plotend) '].png'])
    %             saveas(h,[savepath filename '_Jformation2_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
    %         else
    %             saveas(h,[savepath filename '_Jformation2_.png'])
    %             saveas(h,[savepath filename '_Jformation2_.fig'])
    %         end
    %     end
    
end

%% Junction uniformity (1D histo subsets)
%Plots.JunctionUniformity=1;
if Plots.JunctionUniformity
    disp('Plotting subset 1D Histogram');
    Nsubsets = 6; % or Nsubsets = round(Nplotted/100) to have subsets of 100 traces
    hist1D_sub = zeros(Ybin,Nsubsets);
    MAX = zeros(Nsubsets);
    for k=1:Nsubsets
        substart = plotstart + round((k-1)*Nplotted/Nsubsets);
        subend = round(k*Nplotted/Nsubsets);
        
        hist1D_sub(:,k) = sum(trace_hist(:,substart:subend),2);
        hist1D_sub(:,k) = hist1D_sub(:,k)/round(Nplotted/Nsubsets);
    end
    
    %scroll_subplots(yedges,hist1D_sub,hist1D,plotstart,Nplotted)
    
    % Plot all the subsets in the same figure, offset
    h = figure('Position',[300 150 1100 775],'PaperPositionMode','auto');
    plot_1DHist(hist1D_sub(:,1));
    hold on
    for k=2:Nsubsets
        plot_1DHist(hist1D_sub(:,k)+0.5*(k-1));
    end
    l = legend('Traces 1-1000','Traces 1001-2000','Traces 2001-3000','Traces 3001-4000','Traces 4001-5000','Traces 5001-6000');
    set(l,'fontsize',12,'Location','best')
    
    
end

%% Snapback calculation
if Plots.Snapback == 1
    disp('Plotting snapback calculation');
    Bstart = zeros(1,Nplotted);
    Bend = zeros(1,Nplotted);
    Mstart = zeros(1,Nplotted);
    Mend = zeros(1,Nplotted);
    snapback = zeros(1,Nplotted);
    for i = plotstart:plotend
        try
            ind = find(G(i).g_breaking>3e-1,1,'last'); % position of 1G_0 plateau at breaking
            Bstart(i) = G(i).d_breaking(ind);
            Bend(i) = G(i).d_breaking(end);
            
            ind1 = find(G(i).g_making<3e-1,1,'last'); % position of 1G_0 plateau at making
            Mstart(i) = G(i).d_making(1);
            Mend(i) = G(i).d_making(ind1);
            
            snapback(i) = (Mend(i)-Mstart(i))-(Bend(i)-Bstart(i));
        catch err
        end
    end
    
    %     snapbins = linspace(0,2,100);
    %     snaphisto = hist(snapback,snapbins);
    %     h = figure;
    %     bar(snapbins,snaphisto);
    snaphisto = histogram(snapback);
    title ('Snapback length');
    ylabel('Counts');
    xlabel('Length (nm)');
    set(gca,'Xlim',[0 1])
    set(gca,'fontsize',22,'fontweight','normal')
    set(findall(gcf,'type','text'),'fontsize',22,'fontweight','normal')
    set(gca,'linewidth',2,'box','on')
    set(gcf,'color','white')
    
    if Save == 1
        if Restricted
            saveas(h,[savepath filename '_Snapback_[' num2str(plotstart) '-' num2str(plotend) '].png'])
            saveas(h,[savepath filename '_Snapback_[' num2str(plotstart) '-' num2str(plotend) '].fig'])
        else
            saveas(h,[savepath filename '_Snapback.png'])
            saveas(h,[savepath filename '_Snapback.fig'])
        end
    end
    
end

%% Break and make traces
%{
figure;
semilogy(G(i).d_breaking,G(i).g_breaking)
hold on;
semilogy(G(i).d_making,G(i).g_making)
title(['Trace ' num2str(i)])
xlabel('Electrodes displacement [nm]');
ylabel('Conductance [G_0]');
%set(gca,'Xlim',[-0.2 .5])
%set(gca,'Ylim',[5e-8 3])
%}
% end
